
/////////////////////////////////////////////////////////////////////////////////////////
//    Definition des broches utilisees pour module serie et bibliotheques associees
/////////////////////////////////////////////////////////////////////////////////////////

#include <SoftwareSerial.h>

SoftwareSerial mySerial(11, 10); // RX, TX donc  10 au 22 et 11 au 23


// variable tampon de reception.
// on recoit les infos charactere par charactere

char var1;
char var2;
char var3;
char var4;
char var5;
char var6;
char var7;
char var8;
char var9;
char var10;
char var11;
char var12;
char var13;
char var14;
char var15;
char var16;
char var17;
char var18;
char var19;
char var20;
char var21;
char var22;
char var23;
char var24;
char var25;
char var26;
char var27;
char var28;
char var29;
char var30;
char var31;
char var32;
char var33;
char var34;
char var35;
char var36;
char var37;
char var38;
char var39;
char var40;
char var41;
char var42;


// Declaration des variables qui seront envoyées sur le serveur SQL
String RTCAnnee;
String RTCMois;
String RTCJour;
String RTCHeure;
String RTCMinute;
String Valeur_Int_Temperature;
String Valeur_Int_Humidite;
String Valeur_Ext_Temperature;
String Valeur_Ext_Humidite;
String Valeur_Servo_Porte_Principale;
String ValeurInterF;
String ValeurInterO;
String PorteBloquageO;
String PorteBloquageF;
String Valeur_Servo_Verrou;
String Valeur_Servo_Porte_Pondoir;
String Valeur_Relais_Chauffage;
String Valeur_Relais_Eclairage;
String ValeurInterInfos;
String ValeurInterModeManuel;
String ValeurInterTestMatos;
String ValeurInterFood;
String Valeur_LED_Blanche;
String Valeur_LED_Bleu;
String Valeur_Led_Verte;
String Valeur_Led_Orange_1;
String Valeur_Led_Orange_2;
String Valeur_Led_Rouge_1;
String Valeur_Led_Rouge_2;
String Valeur_Led_Rouge_3;
String ValeurLEDChauffage;


/////////////////////////////////////////////////////////////////////////////////////////
//    Definition des broches utilisees pour module ethernet et bibliotheques associees
/////////////////////////////////////////////////////////////////////////////////////////

#include <SPI.h>
#include <Ethernet.h>

// Configuration carte reseau ethershield
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
byte ip[] = { 192, 168, 1, 151 };
byte gateway[] = { 192, 168, 1, 254 };
byte subnet[] = { 255, 255, 255, 0 };

// Configuration serveur cible
// correspond a IPAddress du serveur SQL
IPAddress server(000, 000, 000, 000); 

EthernetClient client;




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//                                                                               SETUP

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



void setup() {

  // Ouverture du port info
  Serial.begin(9600);

  // Ouverture du port serie
  while (!Serial)
  {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  mySerial.begin(4800);


  // initialisation de la carte RX
  Serial.println("Configuration du LAN");

  Serial.println("Connection reseau...");

  // start the Ethernet connection:
  if (Ethernet.begin(mac) == 0)
  {
    Serial.println("Configuration Ethernet NOK");
    Ethernet.begin(mac, ip);
  }
  else
  {
    Serial.println("Configuration Ethernet OK");
    Serial.println("");
  }



}




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//                                                                               LOOP

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void loop()
{

  // recuperation des donnes du port serie
  RecupData();

  // Envoie de la requete au SRV SQL
  RequeteHTTP();

  delay(5000); // tres inportant, le delais doit etre toujours plus petit que celui de l emission

}




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//                                                                               Fonctions

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////
//                                Fonction -  Connexion HTTP
//////////////////////////////////////////////////////////////////////////////////////////

void connect()
{

  if (client.connect(server, 80))
  {
    Serial.println("Server --> Connecte");
    if (client.connected())
    {
      Serial.println("Client --> Connecte");

      Serial.println("Client --> Envoi de requete");

      // Make a HTTP request:
      //client.print( "GET /add.php?");
      client.print( "GET /Poulailler/update.php?"); // c'est en fait le dossier qui contient le fichier de requete SQL
      
      client.print("RTCAnnee=");
      client.print(RTCAnnee);
      client.print("&&");
      client.print("RTCMois=");
      client.print(RTCMois);
      client.print("&&");
      client.print("RTCJour=");
      client.print(RTCJour);
      client.print("&&");
      client.print("RTCHeure=");
      client.print(RTCHeure);
      client.print("&&");
      client.print("RTCMinute=");
      client.print(RTCMinute);
      client.print("&&");
      client.print("Valeur_Int_Temperature=");
      client.print(Valeur_Int_Temperature);
      client.print("&&");
      client.print("Valeur_Int_Humidite=");
      client.print(Valeur_Int_Humidite);
      client.print("&&");
      client.print("Valeur_Ext_Temperature=");
      client.print(Valeur_Ext_Temperature);
      client.print("&&");
      client.print("Valeur_Ext_Humidite=");
      client.print(Valeur_Ext_Humidite);
      client.print("&&");
      client.print("Valeur_Servo_Porte_Principale=");
      client.print(Valeur_Servo_Porte_Principale);
      client.print("&&");
      client.print("ValeurInterF=");
      client.print(ValeurInterF);
      client.print("&&");
      client.print("ValeurInterO=");
      client.print(ValeurInterO);
      client.print("&&");
      client.print("PorteBloquageO=");
      client.print(PorteBloquageO);
      client.print("&&");
      client.print("PorteBloquageF=");
      client.print(PorteBloquageF);
      client.print("&&");
      client.print("Valeur_Servo_Verrou=");
      client.print(Valeur_Servo_Verrou);
      client.print("&&");
      client.print("Valeur_Servo_Porte_Pondoir=");
      client.print(Valeur_Servo_Porte_Pondoir);
      client.print("&&");
      client.print("Valeur_Relais_Chauffage=");
      client.print(Valeur_Relais_Chauffage);
      client.print("&&");
      client.print("Valeur_Relais_Eclairage=");
      client.print(Valeur_Relais_Eclairage);
      client.print("&&");
      client.print("ValeurInterInfos=");
      client.print(ValeurInterInfos);
      client.print("&&");
      client.print("ValeurInterModeManuel=");
      client.print(ValeurInterModeManuel);
      client.print("&&");
      client.print("ValeurInterTestMatos=");
      client.print(ValeurInterTestMatos);
      client.print("&&");
      client.print("ValeurInterFood=");
      client.print(ValeurInterFood);
      client.print("&&");
      client.print("Valeur_LED_Blanche=");
      client.print(Valeur_LED_Blanche);
      client.print("&&");
      client.print("Valeur_LED_Bleu=");
      client.print(Valeur_LED_Bleu);
      client.print("&&");
      client.print("Valeur_Led_Verte=");
      client.print(Valeur_Led_Verte);
      client.print("&&");
      client.print("Valeur_Led_Orange_1=");
      client.print(Valeur_Led_Orange_1);
      client.print("&&");
      client.print("Valeur_Led_Orange_2=");
      client.print(Valeur_Led_Orange_2);
      client.print("&&");
      client.print("Valeur_Led_Rouge_1=");
      client.print(Valeur_Led_Rouge_1);
      client.print("&&");
      client.print("Valeur_Led_Rouge_2=");
      client.print(Valeur_Led_Rouge_2);
      client.print("&&");
      client.print("Valeur_Led_Rouge_3=");
      client.print(Valeur_Led_Rouge_3);
      client.print("&&");
      client.print("ValeurLEDChauffage=");
      client.print(ValeurLEDChauffage);

      client.println( " HTTP/1.1");
      
	  //ici on indique l’hote soit ladresse ip fixe soit un nom de domaine
      client.println( "Host: NomDeDomaine.free.fr" ); //free
      
      client.println( "Connection: close" );
      client.println();
      client.println();
      client.stop();
      Serial.println("Client --> Requete envoyee");
    }
    else
    {
      Serial.println("Client --> ERREUR NON CONNECTE");
    }
  }

  else
  {
    Serial.println("Server --> ERREUR NON CONNECTE");
  }
}



//////////////////////////////////////////////////////////////////////////////////////////
//                                Fonction -  Requete HTTP
//////////////////////////////////////////////////////////////////////////////////////////

void RequeteHTTP()
{
  // gestion de l'envoie de la requete HTTP
  if (client.available())
  {
    Serial.println("Client Disponible -->  OK");
    char c = client.read();
    Serial.print(c);
  }
  else
  {
    Serial.println("Client Disponible --> ERREUR NOK");
  }

  // si client est deconecté on reconnecte et envoie la requete
  if (!client.connected())
  {
    Serial.println("Client Connecte --> NOK");

    Serial.println("Client --> Stop");
    client.stop();

    Serial.println("Client --> Reconnection");
    connect();
    // on reste 1 sec avant de couper la requete.
    delay(1000);

  }
  else
  {
    Serial.println("Client Connecte --> OK");
  }
}




//////////////////////////////////////////////////////////////////////////////////////////
//                    Fonction -  Recuperation des donnes via la liaison serie
//////////////////////////////////////////////////////////////////////////////////////////


void RecupData()
{
  if (mySerial.available()) {


    var1 = mySerial.read();
    delay(50);
    var2 = mySerial.read();
    delay(50);
    var3 = mySerial.read();
    delay(50);
    var4 = mySerial.read();
    delay(50);
    var5 = mySerial.read();
    delay(50);
    var6 = mySerial.read();
    delay(50);
    var7 = mySerial.read();
    delay(50);
    var8 = mySerial.read();
    delay(50);
    var9 = mySerial.read();
    delay(50);
    var10 = mySerial.read();
    delay(50);
    var11 = mySerial.read();
    delay(50);
    var12 = mySerial.read();
    delay(50);
    var13 = mySerial.read();
    delay(50);
    var14 = mySerial.read();
    delay(50);
    var15 = mySerial.read();
    delay(50);
    var16 = mySerial.read();
    delay(50);
    var17 = mySerial.read();
    delay(50);
    var18 = mySerial.read();
    delay(50);
    var19 = mySerial.read();
    delay(50);
    var20 = mySerial.read();
    delay(50);
    var21 = mySerial.read();
    delay(50);
    var22 = mySerial.read();
    delay(50);
    var23 = mySerial.read();
    delay(50);
    var24 = mySerial.read();
    delay(50);
    var25 = mySerial.read();
    delay(50);
    var26 = mySerial.read();
    delay(50);
    var27 = mySerial.read();
    delay(50);
    var28 = mySerial.read();
    delay(50);
    var29 = mySerial.read();
    delay(50);
    var30 = mySerial.read();
    delay(50);
    var31 = mySerial.read();
    delay(50);
    var32 = mySerial.read();
    delay(50);
    var32 = mySerial.read();
    delay(50);
    var33 = mySerial.read();
    delay(50);
    var34 = mySerial.read();
    delay(50);
    var35 = mySerial.read();
    delay(50);
    var36 = mySerial.read();
    delay(50);
    var37 = mySerial.read();
    delay(50);
    var38 = mySerial.read();
    delay(50);
    var39 = mySerial.read();
    delay(50);
    var40 = mySerial.read();
    delay(50);


    /*

            Serial.print("var1 = ");
            Serial.println(var1);
            Serial.print("var2 = ");
            Serial.println(var2);
            Serial.print("var3 = ");
            Serial.println(var3);
            Serial.print("var4 = ");
            Serial.println(var4);
            Serial.print("var5 = ");
            Serial.println(var5);
            Serial.print("var6 = ");
            Serial.println(var6);
            Serial.print("var7 = ");
            Serial.println(var7);
            Serial.print("var8 = ");
            Serial.println(var8);
            Serial.print("var9 = ");
            Serial.println(var9);
            Serial.print("var10 = ");
            Serial.println(var10);
            Serial.print("var11 = ");
            Serial.println(var11);
            Serial.print("var12 = ");
            Serial.println(var12);
            Serial.print("var13 = ");
            Serial.println(var13);
            Serial.print("var14 = ");
            Serial.println(var14);
            Serial.print("var15 = ");
            Serial.println(var15);
            Serial.print("var16 = ");
            Serial.println(var16);
            Serial.print("var17 = ");
            Serial.println(var17);
            Serial.print("var18 = ");
            Serial.println(var18);
            Serial.print("var19 = ");
            Serial.println(var19);
            Serial.print("var20 = ");
            Serial.println(var20);
            Serial.print("var21 = ");
            Serial.println(var21);
            Serial.print("var22 = ");
            Serial.println(var22);
            Serial.print("var23 = ");
            Serial.println(var23);
            Serial.print("var24 = ");
            Serial.println(var24);
            Serial.print("var25 = ");
            Serial.println(var25);
            Serial.print("var26 = ");
            Serial.println(var26);
            Serial.print("var27 = ");
            Serial.println(var27);
            Serial.print("var28 = ");
            Serial.println(var28);
            Serial.print("var29 = ");
            Serial.println(var29);
            Serial.print("var30 = ");
            Serial.println(var30);
            Serial.print("var31 = ");
            Serial.println(var31);
            Serial.print("var32 = ");
            Serial.println(var32);
            Serial.print("var33 = ");
            Serial.println(var33);
            Serial.print("var34 = ");
            Serial.println(var34);
            Serial.print("var35 = ");
            Serial.println(var35);
            Serial.print("var36 = ");
            Serial.println(var36);
            Serial.print("var37 = ");
            Serial.println(var37);
            Serial.print("var38 = ");
            Serial.println(var38);
            Serial.print("var39 = ");
            Serial.println(var39);
            Serial.print("var40 = ");
            Serial.println(var40);
            Serial.print("var41 = ");
            Serial.println(var41);
            Serial.print("var42 = ");
            Serial.println(var42);

    */

    // concatenation des caracteres pour recuperer les valeurs d origine
    
    RTCAnnee = String(var1) + String(var2);
    RTCMois = String(var3) + String(var4);
    RTCJour = String(var5) + String(var6);
    RTCHeure = String(var7) + String(var8);
    RTCMinute = String(var9) + String(var10);
    Valeur_Int_Temperature = String(var11) + String(var12);
    Valeur_Int_Humidite =  String(var13) + String(var14);
    Valeur_Ext_Temperature = String(var15) + String(var16);
    Valeur_Ext_Humidite =  String(var17) + String(var18);
    Valeur_Servo_Porte_Principale =  String(var19);
    ValeurInterF =  String(var20);
    ValeurInterO =  String(var21);
    PorteBloquageO =  String(var22);
    PorteBloquageF =  String(var23);
    Valeur_Servo_Verrou =  String(var24);
    Valeur_Servo_Porte_Pondoir =  String(var25);
    Valeur_Relais_Chauffage =  String(var26);
    Valeur_Relais_Eclairage =  String(var27);
    ValeurInterInfos =  String(var28);
    ValeurInterModeManuel =  String(var29);
    ValeurInterTestMatos =  String(var30);
    ValeurInterFood =  String(var31);
    Valeur_LED_Blanche =  String(var32);
    Valeur_LED_Bleu =  String(var33);
    Valeur_Led_Verte =  String(var34);
    Valeur_Led_Orange_1 =  String(var35);
    Valeur_Led_Orange_2 =  String(var36);
    Valeur_Led_Rouge_1 =  String(var37);
    Valeur_Led_Rouge_2 =  String(var38);
    Valeur_Led_Rouge_3 =  String(var39);
    ValeurLEDChauffage =  String(var40);


    // affichage des valeurs recupéréés

    Serial.println("RTCAnnee = " + RTCAnnee);
    Serial.println("RTCMois = " + RTCMois);
    Serial.println("RTCJour = " + RTCJour);
    Serial.println("RTCHeure = " + RTCHeure);
    Serial.println("RTCMinute = " + RTCMinute);
    Serial.println("Valeur_Int_Temperature = " + Valeur_Int_Temperature);
    Serial.println("Valeur_Int_Humidite = " + Valeur_Int_Humidite);
    Serial.println("Valeur_Ext_Temperature = " + Valeur_Ext_Temperature);
    Serial.println("Valeur_Ext_Humidite = " + Valeur_Ext_Humidite);
    Serial.println("Valeur_Servo_Porte_Principale = " + Valeur_Servo_Porte_Principale);
    Serial.println("ValeurInterF = " + ValeurInterF);
    Serial.println("ValeurInterO = " + ValeurInterO);
    Serial.println("PorteBloquageO = " + PorteBloquageO);
    Serial.println("PorteBloquageF = " + PorteBloquageF);
    Serial.println("Valeur_Servo_Verrou = " + Valeur_Servo_Verrou);
    Serial.println("Valeur_Servo_Porte_Pondoir = " + Valeur_Servo_Porte_Pondoir);
    Serial.println("Valeur_Relais_Chauffage = " + Valeur_Relais_Chauffage);
    Serial.println("Valeur_Relais_Eclairage = " + Valeur_Relais_Eclairage);
    Serial.println("ValeurInterInfos = " + ValeurInterInfos);
    Serial.println("ValeurInterModeManuel = " + ValeurInterModeManuel);
    Serial.println("ValeurInterTestMatos = " + ValeurInterTestMatos);
    Serial.println("ValeurInterFood = " + ValeurInterFood);
    Serial.println("Valeur_LED_Blanche = " + Valeur_LED_Blanche);
    Serial.println("Valeur_LED_Bleu = " + Valeur_LED_Bleu);
    Serial.println("Valeur_Led_Verte = " + Valeur_Led_Verte);
    Serial.println("Valeur_Led_Orange_1 = " + Valeur_Led_Orange_1);
    Serial.println("Valeur_Led_Orange_2 = " + Valeur_Led_Orange_2);
    Serial.println("Valeur_Led_Rouge_1 = " + Valeur_Led_Rouge_1);
    Serial.println("Valeur_Led_Rouge_2 = " + Valeur_Led_Rouge_2);
    Serial.println("Valeur_Led_Rouge_3 = " + Valeur_Led_Rouge_3);
    Serial.println("ValeurLEDChauffage = " + ValeurLEDChauffage);
    Serial.println("");
  }
}



